minor bug fix
[distro-setup] / btrbk-run
index 6ef3747a8f53fb868775d8ea6a2601d03e79fd28..10bd6382c65df24a4ec1efe35a45270e70ad9005 100644 (file)
--- a/btrbk-run
+++ b/btrbk-run
 
 # todo: if we cancel in the middle of a btrfs send, then run again immediately, the received subvolume doesn't get a Received UUID: field, and we won't mount it. Need to figure out a solution that will fix this.
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
-[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
+
+source /usr/local/lib/err
 
 usage() {
   cat <<'EOF'
@@ -35,11 +35,24 @@ EOF
   exit $1
 }
 
-script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
+rsync-dirs() {
+  local host=$1
+  local path=$2
+  m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
+}
 
-# note q is owned by root:1000
-# note p/m is owned 1000:1000 and chmod 700
 
+pre="${0##*/}: "
+m() { if $verbose; then printf "$pre%s\n"  "$*"; fi;  "$@"; }
+e() { printf "$pre%s\n"  "$*"; }
+die() { printf "$pre%s\n" "$*" >&2;  exit 1; }
+
+# latest $MAIL_HOST
+if [[ -e /b/bash_unpublished/source-state ]]; then
+  source /b/bash_unpublished/source-state
+fi
+
+# note q is owned by root:1000
 
 mountpoints=()
 
@@ -51,16 +64,28 @@ dry_run=false # mostly for testing
 rate_limit=no
 verbose=true; verbose_arg=-v
 progress_arg="--progress"
+pull_reexec=false
 
 default_args_file=/etc/btrbk-run.conf
 if [[ -s $default_args_file ]]; then
   set -- $(< $default_args_file) "$@"
+  # i havent used this feature yet, so warn about it
+  echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
+  cat $default_args_file
+  sleep 5
 fi
 
-temp=$(getopt -l help cl:m:nps:t:vh "$@") || usage 1
+cron=false
+orig_args=("$@")
+temp=$(getopt -l cron,pull-reexec,help cl:m:npqs:t:vh "$@") || usage 1
 eval set -- "$temp"
 while true; do
   case $1 in
+    --cron)
+      cron=true
+      pre=
+      shift
+      ;;
     # only creates the config file, does not run btrbk
     -c) conf_only=true; shift ;;
     # bytes per second, suffix k m g
@@ -69,6 +94,7 @@ while true; do
     -m) IFS=, mountpoints=($2); unset IFS; shift 2 ;;
     -n) dry_run=true; dry_run_arg=-n; shift ;;
     -p) progress_arg="--progress"; shift ;;
+    --pull-reexec) pull_reexec=true; shift ;;
     -q) verbose=false; verbose_arg=; progress_arg=; shift ;;
     # source host to receive a backup from
     -s) source=$2; shift 2 ;;
@@ -78,48 +104,84 @@ while true; do
     -v) verbose=true; verbose_arg=-v; shift ;;
     -h|--help) usage ;;
     --) shift; break ;;
-    *) echo "$0: Internal error!" ; exit 1 ;;
+    *) die "Internal error!" ;;
   esac
 done
 
-# usefull commands are resume and archive
+# only tested commands are resume and archive
 cmd_arg=${1:-run}
 
-if [[ -s $default_args_file ]]; then
-  echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
-  cat $default_args_file
-  sleep 5
+case $cmd_arg in
+  run|resume|archive) : ;;
+  *) die "untested command arg" ;;
+esac
+
+if (( $# > 1 )); then
+  die: "only 1 nonoption arg is supported"
 fi
 
 if [[ -v targets && $source ]]; then
-  echo "$0: error: -t and -s are mutually exclusive" >&2
-  exit 1
+  die "error: -t and -s are mutually exclusive"
 fi
 
-echo -e "$0: options: conf_only=$conf_only\ndry_run=$dry_run\nrate_limit=$rate_limit\nverbose=$verbose\ncmd_arg=$cmd_arg"
+if $verbose; then
+  printf "options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
+fi
+### end options parsing
+
+# TODO: i wonder if there should be an option to send to the default
+# targets, plus any given on the command line.
 
 # set default targets
 if [[ ! -v targets && ! $source ]]; then
+  if [[ $HOSTNAME != "$MAIL_HOST" ]] && $cron ; then
+    echo "MAIL_HOST=$MAIL_HOST, nothing to do"
+    exit 0
+  fi
+
+  at_work=false
+
   case $HOSTNAME in
-    x2|kw)
-      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
-        targets=($HOME_DOMAIN)
+    kw)
+      at_work=true
+      ;;&
+    x2|x3)
+      if ping -q -c1 -w1 hal.office.fsf.org \
+              && ip n show 192.168.0.26 | grep . &>/dev/null; then
+      at_work=true
+      fi
+      ;;&
+    kw|x2|x3)
+      if $at_work && ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
+        home=iank.vpn.office.fsf.org
+      else
+        home=b8.nz
       fi
+      ;;&
+    kw)
+      targets=($home x2)
+      ;;
+    x2|x3)
+      targets=($home kw)
       ;;
     tp)
-      targets=(frodo)
-      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
-        if timeout -s 9 10 ssh x2 :; then
-          targets+=(x2)
-        fi
+      # kd disabled temporarily while its hot and i plan to work on it.
+      #targets=(frodo kd)
+      targets=(frodo x3.b8.nz)
+      # might not be connected to the vpn
+      if timeout -s 9 10 ssh kw :; then
+        targets+=(kw)
       fi
       ;;
-    frodo)
-      targets=()
+    kd)
+      targets=(frodo tp)
+      # might not be connected to the vpn
+      if timeout -s 9 10 ssh kw :; then
+        targets+=(kw)
+      fi
       ;;
     *)
-      echo "$0: error: no default targets for this host, use -t"
-      exit 1
+      die "error: no default targets for this host, use -t"
       ;;
   esac
 fi
@@ -133,57 +195,137 @@ if [[ $source ]]; then
 fi
 
 
-
-# set default mountpoints
-case $HOSTNAME in
-  # no remote backups atm. note, if we do enable this, configuration below will need some changes.
-  #  frodo)
-  #    prospective_mps=(/i)
-  #    ;;
-  *)
-    prospective_mps=(/a /q)
-    if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
-      prospective_mps+=(/o)
+if [[ $mountpoints ]]; then
+  for mp in ${mountpoints[@]}; do # default mountpoints to sync
+    if [[ -e /nocow/btrfs-stale/$mp ]]; then
+      die "error: $mp is stale, mount-latest-subvol first"
     fi
-    ;;
-esac
-case ${targets[0]} in
-  kw|kww)
-    prospective_mps=(/a)
-    ;;
-esac
-
-for mp in ${prospective_mps[@]}; do # default mountpoints to sync
-  if [[ -e /nocow/btrfs-stale/$mp ]]; then
-    echo "$0: warning: $mp stale, not adding to default mountpoints"
-    continue
-  fi
-  if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
-    mountpoints+=($mp)
-  fi
-done
+  done
+else
+  # set default mountpoints
+  case $HOSTNAME in
+    # no remote backups atm. note, if we do enable this, configuration below will need some changes.
+    #  frodo)
+    #    prospective_mps=(/i)
+    #    ;;
+    *)
+      prospective_mps=(/a /q)
+      if [[ $source ]]; then
+        source_state="$(ssh $source cat /a/bin/bash_unpublished/source-state)"
+        eval "$source_state"
+        source_host="$(ssh $source cat /etc/hostname)"
+        if [[ $source_host == "$MAIL_HOST" ]]; then
+          prospective_mps+=(/o)
+        fi
+      else
+        if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+          prospective_mps+=(/o)
+        fi
+      fi
+      ;;
+  esac
+  for mp in ${prospective_mps[@]}; do # default mountpoints to sync
+    if [[ -e /nocow/btrfs-stale/$mp ]]; then
+      e "warning: $mp stale, not adding to default mountpoints"
+      continue
+    fi
+    if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
+      mountpoints+=($mp)
+    fi
+  done
+fi
 
 echo "mountpoints: ${mountpoints[*]}"
 
 ##### end command line parsing ########
 
-rsync-dirs() {
-  local host=$1
-  local path=$2
-  m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
-}
+if [[ $source ]]; then
+  if [[ $(ssh $source systemctl is-active btrbk.service) != inactive ]]; then
+    echo "$0: error: cron btrbk is running on source. exiting out of caution"
+    exit 1
+  fi
+fi
+
+# pull_reexec stops us from getting into an infinite loop if there is some
+# kind of weird problem
+pulla=false
+for m in "${mountpoints[@]}"; do
+  if [[ $m == /a ]]; then
+    pulla=true
+    break
+  fi
+done
+if ! $pull_reexec && [[ $source ]] && $pulla ; then
+  tmpf=$(mktemp)
+  scp $source:/a/bin/distro-setup/btrbk-run $tmpf
+  if ! diff -q $tmpf $BASH_SOURCE; then
+    e "found newer version on host $source. reexecing"
+    install -T $tmpf /usr/local/bin/btrbk-run
+    m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
+    exit
+  fi
+fi
+
 
 
-m() { printf "%s: %s\n" "${0##*/}" "$*";  "$@"; }
 
 
 if ! which btrbk &>/dev/null; then
-  echo "$0: error: no btrbk binary found"
-  exit 1
+  die "error: no btrbk binary found"
 fi
 # if our mountpoints are from stale snapshots,
 # it doesn't make sense to do a backup.
-check-subvol-stale ${mountpoints[@]} || exit 1
+check-subvol-stale ${mountpoints[@]} || die "found stale mountpoints in ${mountpoints[*]}"
+
+# for an initial run, btrbk requires the dir to exist.
+mkdir -p /mnt/root/btrbk
+local_zone=$(date +%z)
+
+if [[ $source ]]; then
+  if ! zone=$(ssh root@$source date +%z); then
+    die failed to ssh to root@$source
+  fi
+  if [[ $zone != $local_zone ]]; then
+    die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
+  fi
+
+else
+
+  sshable=()
+  sshfail=()
+  min_idle_ms=$((1000 * 60 * 15))
+  for h in ${targets[@]}; do
+    if zone=$(ssh root@$h "mkdir -p /mnt/root/btrbk && date +%z"); then
+      # This is a separate ssh because xprintidle can fail and thats ok.
+      if $cron && idle_ms=$(ssh $h DISPLAY=:0 xprintidle); then
+        if (( idle_ms < min_idle_ms )); then
+
+          # Ignore this host. i sometimes use a non-main machine for
+          # testing or web browsing, knowing that everything will be wiped
+          # by the next backup, but I dont want it to happen as Im using
+          # it from cronjob.
+          e "warning: $h: active X session in the last 15 minutes, skipping for now"
+          continue
+        fi
+      fi
+      sshable+=($h)
+      if [[ $zone != $local_zone ]]; then
+        die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
+      fi
+    else
+      sshfail+=($h)
+    fi
+  done
+  if [[ ! ${sshable[@]} ]] || { ! $cron && [[ ${sshfail[@]} ]]; }; then
+    die "failed to ssh to hosts: ${sshfail[*]}"
+  else
+    if [[ ${sshfail[@]} ]]; then
+      ret=1
+      e "error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
+    fi
+    targets=(${sshable[@]})
+  fi
+fi
 
 
 cat >/etc/btrbk.conf <<EOF
@@ -196,8 +338,9 @@ ssh_identity /root/.ssh/home
 # transaction info.
 transaction_syslog local7
 
-# 20%ish speedup[]
-stream_buffer 512m
+# note, i had this because man said 20% speedup, but ran into
+# this issue, https://github.com/digint/btrbk/issues/275
+#stream_buffer 512m
 
 # so we only run one at a time
 lockfile                   /var/lock/btrbk.lock
@@ -226,11 +369,6 @@ EOF
 
 
 
-for tg in ${targets[@]:-$HOSTNAME}; do
-  # for an initial run, btrbk requires the dir to exist.
-  ssh root@$tg mkdir -p /mnt/root/btrbk
-done
-
 
 
 vol=/mnt/root
@@ -268,6 +406,7 @@ fi
 
 if $dry_run; then
   m btrbk -v -n $cmd_arg
+  exit 0
 elif [[ $cmd_arg == archive ]]; then
   if [[ $source ]]; then
     m btrbk $verbose_arg $progress_arg $cmd_arg ssh://$source$vol $vol
@@ -298,13 +437,14 @@ if mountpoint $rsync_mountpoint >/dev/null; then
   done
 fi
 
-/a/bin/distro-setup/install-my-scripts
 if [[ $source ]]; then
-  m mount-latest-subvol
+  m mount-latest-subvol $verbose_arg
 else
-  m mount-latest-remote ${targets[@]}
+  m /a/exe/mount-latest-remote ${targets[@]}
 fi
 
+exit $ret
+
 # todo: move variable data we don't care about backing up
 # to /nocow and symlink it.